MESSAGE "Loading PaintPAL Installation Program..."
SETUIMODE STANDARD
MESSAGE "Loading PaintPAL Installation Program..."
SETCANVAS DEFAULT
PAINTCANVAS FILL "" ATTRIBUTE 113 ALL
PAINTCANVAS FILL " " ATTRIBUTE 113 0, 0, 0, 79
PAINTCANVAS FILL " " ATTRIBUTE 113 24, 0, 24, 79

PROC Strip_Trailing_BackSlash(AnyString)
  AnyString = IIF(SubStr(AnyString, Len(AnyString), 1) = "\\",
                  SubStr(AnyString, 1, Len(AnyString)-1),
                  AnyString)
  RETURN AnyString
ENDPROC

PROC Extract_Files()
  PRIVATE CommandStr, junk

  PAINTCANVAS FILL " " ATTRIBUTE 113 ALL
  MESSAGE "Installing PaintPAL to " + InstDir + " ..."
  @ 0, 0
  FILEWRITE Instdir + "\\ppinst.bat" FROM
       "@echo off\n" +
       SubStr(InstDir, 1, 2) + "\n" +
       "cd " + InstDir + "\n" +
       SDir() + "lha e /m1 /s1 /w" + InstDir + " " + SDir() + "PP30 *.*" + "\n"
  IF NOT IsFile(InstDir + "\\ppinst.bat") THEN
     MESSAGE "Unable to create intermediate batch file.  Press any key..."
     junk = getchar()
     EXIT
  ENDIF
  RUN NOREFRESH InstDir + "\\ppinst"
  ; Delete the Batch File
  EDITOR NEW InstDir + "\\ppinst.bat" {Cancel} {Yes}
  PAINTCANVAS FILL "" ATTRIBUTE 113 ALL
  PAINTCANVAS FILL " " ATTRIBUTE 113 0, 0, 0, 79
  PAINTCANVAS FILL " " ATTRIBUTE 113 24, 0, 24, 79
  MESSAGE ""

  ; PaintPAL_Generated_Code_Begin(443956555)

  SHOWDIALOG "PaintPAL 3.0 Installation Complete!"
     @6,9 HEIGHT 12 WIDTH 60

     @1,2
     ?? "PaintPAL 3.0 has been successfully installed!  Target"
     @2,2
     ?? "Software recommends adding the PaintPAL directory to"
     @3,2
     ?? "the path statement in your AUTOEXEC.BAT file so you'll"
     @4,2
     ?? "be able to run PaintPAL from any directory simply by"

     @5,2
     ?? "typing \"PAINTPAL\" at the DOS prompt.  Now's a good"
     @6,2
     ?? "time to fill out your registration card!"

     PUSHBUTTON @8,20 WIDTH 17
        "Let's Go!!!"
        OK
        VALUE ""
        TAG "1"
        TO junkvar
  ENDDIALOG

  ; PaintPAL_Generated_Code_End(443956555)
  SETDIR InstDir
ENDPROC

PROC Install_PaintPAL()
  PRIVATE InstDir, JunkVar, DirStatus

  InstDir = "C:\\PAINTPAL"
  WHILE TRUE
      MESSAGE ""
      ; PaintPAL_Generated_Code_Begin(443956086)

      SHOWDIALOG "PaintPAL Installation Program"
         @8,11 HEIGHT 8 WIDTH 55

         ACCEPT @2,2 WIDTH 49
            "A132"
            PICTURE "&:\\*!"
            TAG "InstDir"
            TO InstDir

         LABEL @1,1
            "Into what directory should PaintPAL be installed?"
            FOR "InstDir"

         PUSHBUTTON @4,11 WIDTH 15
            "~P~roceed"
            OK
            DEFAULT
            VALUE ""
            TAG ""
            TO junkvar

         PUSHBUTTON @4,27 WIDTH 15
            "Cancel"
            CANCEL
            VALUE ""
            TAG ""
            TO junkvar
      ENDDIALOG

      ; PaintPAL_Generated_Code_End(443956086)
      IF NOT retval THEN
         QUITLOOP
      ENDIF
      MESSAGE "Checking Directory Status..."
      InstDir = Strip_Trailing_BackSlash(InstDir)
      DirStatus = DirExists(InstDir)
      MESSAGE ""
      SWITCH
        CASE DirStatus = 1:
            ; PaintPAL_Generated_Code_Begin(443956360)

            ; PaintPAL_Color_Setup_Begin
            GETCOLORS TO PaintPAL.OriginalPalette
            DYNARRAY PaintPAL.ColorDeviations[]
            PaintPAL.ColorDeviations[1031] =  64  ;Border Inactive
            PaintPAL.ColorDeviations[1032] =  79  ;Border Active
            PaintPAL.ColorDeviations[1033] =  74  ;Border Dragging/Icons
            PaintPAL.ColorDeviations[1036] =  79  ;Background Text
            PaintPAL.ColorDeviations[1037] =  64  ;Label Inactive
            PaintPAL.ColorDeviations[1038] =  79  ;Label Selected
            PaintPAL.ColorDeviations[1039] =  78  ;Label Shortcut
            PaintPAL.ColorDeviations[1045] =  64  ;Pushbutton Shadow
            SETCOLORS FROM PaintPAL.ColorDeviations
            RELEASE VARS PaintPAL.ColorDeviations
            ; PaintPAL_Color_Setup_End

            SHOWDIALOG "Directory Already Exists!"
               @7,16 HEIGHT 9 WIDTH 45

               @1,2
               ?? "Warning.  The directory you specified"

               @2,2
               ?? "already exists.  If you continue, any"

               @3,2
               ?? "old PaintPAL files will be overwritten."

               PUSHBUTTON @5,7 WIDTH 14
                  "~C~ontinue"
                  OK
                  DEFAULT
                  VALUE ""
                  TAG "1"
                  TO junkvar

               PUSHBUTTON @5,22 WIDTH 14
                  "Cancel"
                  CANCEL
                  VALUE ""
                  TAG "2"
                  TO junkvar
            ENDDIALOG

            ; PaintPAL_Color_Cleanup_Begin
            SETCOLORS FROM PaintPAL.OriginalPalette
            RELEASE VARS PaintPAL.OriginalPalette
            ; PaintPAL_Color_Cleanup_End

            ; PaintPAL_Generated_Code_End(443956360)
            IF NOT retval THEN
               LOOP
            ENDIF
            Extract_Files()

        CASE DirStatus = -1:
            ; PaintPAL_Generated_Code_Begin(443956361)

            ; PaintPAL_Color_Setup_Begin
            GETCOLORS TO PaintPAL.OriginalPalette
            DYNARRAY PaintPAL.ColorDeviations[]
            PaintPAL.ColorDeviations[1031] =  64  ;Border Inactive
            PaintPAL.ColorDeviations[1032] =  79  ;Border Active
            PaintPAL.ColorDeviations[1033] =  74  ;Border Dragging/Icons
            PaintPAL.ColorDeviations[1036] =  79  ;Background Text
            PaintPAL.ColorDeviations[1037] =  64  ;Label Inactive
            PaintPAL.ColorDeviations[1038] =  79  ;Label Selected
            PaintPAL.ColorDeviations[1039] =  78  ;Label Shortcut
            PaintPAL.ColorDeviations[1045] =  64  ;Pushbutton Shadow
            SETCOLORS FROM PaintPAL.ColorDeviations
            RELEASE VARS PaintPAL.ColorDeviations
            ; PaintPAL_Color_Setup_End

            SHOWDIALOG "Invalid Directory Name!"
               @7,14 HEIGHT 9 WIDTH 50

               ; PaintPAL_Static_Text_Begin
               PAINTCANVAS FILL " " ATTRIBUTE 79 1,2,1,41
               @1,2
               ?? "Sorry.  The directory name you specified"
               PAINTCANVAS ATTRIBUTE 79 1,2,1,41
               ; PaintPAL_Static_Text_End

               ; PaintPAL_Static_Text_Begin
               PAINTCANVAS FILL " " ATTRIBUTE 79 2,2,2,45
               @2,2
               ?? "is invalid.  Please enter a valid directory"
               PAINTCANVAS ATTRIBUTE 79 2,2,2,45
               ; PaintPAL_Static_Text_End

               ; PaintPAL_Static_Text_Begin
               PAINTCANVAS FILL " " ATTRIBUTE 79 3,2,3,46
               @3,2
               ?? "name into which PaintPAL should be installed."
               PAINTCANVAS ATTRIBUTE 79 3,2,3,46
               ; PaintPAL_Static_Text_End

               PUSHBUTTON @5,17 WIDTH 14
                  "Ok"
                  OK
                  VALUE ""
                  TAG "2"
                  TO junkvar
            ENDDIALOG

            ; PaintPAL_Color_Cleanup_Begin
            SETCOLORS FROM PaintPAL.OriginalPalette
            RELEASE VARS PaintPAL.OriginalPalette
            ; PaintPAL_Color_Cleanup_End

            ; PaintPAL_Generated_Code_End(443956361)
            LOOP

        OTHERWISE:
          MESSAGE "Creating " + InstDir + " ..."
          RUN NOREFRESH "md " + InstDir
          IF DirExists(InstDir) <> 1 THEN
             MESSAGE "Unable to create " + InstDir + ".  Press any key..."
             junkvar = getchar()
             MESSAGE ""
             LOOP
          ENDIF
          Extract_Files()
      ENDSWITCH
      QUITLOOP
  ENDWHILE
ENDPROC

Install_PaintPAL()
MESSAGE "Exiting to DOS..."
EXIT




